import { Input, Output, EventEmitter, OnInit } from '@angular/core';
import { FormControl } from '@angular/forms';

export abstract class NativeInputComponent implements OnInit {

	@Input()
	control: FormControl;

	@Input()
	meta;

	@Output()
	call: EventEmitter<string> = new EventEmitter<string>();

	exposeMetaInTemplate: string[] = [];

	ngOnInit() {
		// Move meta variables up a level, for direct access in templates
		this.exposeMetaInTemplate.map(p => this[p] = this.meta[p] !== undefined ? this.meta[p] : this[p]);
	}

	handle(fnId: string, val: any) {
		this.call.emit(fnId);
	}

}
